Online Tile Map Editor
======================

A web based tile map editor for all kinds of 2d games and applications.  
**Open source under the [MIT](http://opensource.org/licenses/MIT) or [CC-BY-SA](https://creativecommons.org/licenses/by-sa/2.0/) license.**  
**Live Demo: [http://elias-schuett.de/git/Online-Tile-Map-Editor/](http://elias-schuett.de/git/Online-Tile-Map-Editor/)**  

----

![preview](http://elias-schuett.de/img/content/online-tile-map-editor.png)

##Features

###### Implemented
  
  * Menubar
  * Tileset handling
  * Layer handling
  * Drawing
  * Fancy UI

###### In Progress

  * Animated tiles `(for a more alive environment)`
  * Viewport `(for in-game effects e.g. parallax)`
  * Tools `(select, fill, flip/rotate, ...)`
  * Save/Load `(JSON, XML, ...)`


##Dependencies

  * **[HTML5 FileReader API](http://www.w3.org/TR/FileAPI/#dfn-filereader)** [1]
  * **[jQuery](http://jquery.com/), [jQuery UI](http://jqueryui.com/)**
  * **[Underscore.js](http://underscorejs.org/)**, **[RequireJS](http://requirejs.org/)**


######Browser Support

  * Google Chrome
  * Mozilla Firefox
  * Opera (latest)
  * Internet Explorer 9+ [2]

Version info will be added soon.

----
[1] Ajax is used as a fallback solution  
[2] No alpha definition support (yet)
